<?php
/******************************************************************************
  Template 1.1

  Copyright (C) 1998  Muze 

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  --------------------------------------------------------------------------

  Parses templates which can include simple variables ($var) and arrays
  ($var[]). Arrays must be enclosed in "{" and "}" tags. The complete html
  will be printed as many times as there are items in the first array listed.
  Example: if $var1[] has 2 items, and $var2[] has 3, "{ $var1[], $var2[] }" 
    will output only the first two values of $var1[] and $var2[].

  "{" can be escaped with "{{". "$" can be escaped with "\$".

  Warning: when including javascript in a template, don't forget
  to escape the brackets "{" with "{{", or else everything inside the
  brackets will be ignored.

  $line, $vars, $dt_explode, $dt_result, $dt_temp, $dt_i, $dt_multiple 

  --------------------------------------------------------------------------

  Changes from version 1.0:
  - template 1.1 is now compatible with php 4. 
    (return from inside eval() is no longer allowed.)

*******************************************************************************/

  function EvalLine($line, $vars) {
    eval("global $vars;");
    if (ereg("[^{]({[^{}][^}]*})",$line, $dt_result)) { 			// found a multiple 
      $dt_explode=explode($dt_result[1], $line);				// explode on the multiple part

      $dt_result[1]=substr($dt_result[1],1,strlen($dt_result[1])-2); 		// cut "{" and "}"            

      $dt_temp=explode("[]",$dt_result[1]);
      $dt_temp=substr(strrchr($dt_temp[0], "\$"),1);				// get the first array variable name

      $dt_temp=@count($$dt_temp);						// count the length of the array
                                                                        	// @ suppresses warnings when the array is not defined

      $dt_result[1]=ereg_replace("\\\$([^\[]*)\[\]","\$\\1[\$dt_i]",$dt_result[1]); 
										// this line replaces things like $var[] with $var[$dt_i].

      for ($dt_i=0;$dt_i<$dt_temp;$dt_i++) {
        eval("\$dt_multiple.=\"$dt_result[1]\";");                   		// let eval fill in the values
      }
      reset($dt_explode);
      return EvalLine($dt_explode[0], $vars).$dt_multiple.EvalLine($dt_explode[1], $vars); 
										// if $dt_middle occurs more than once, exactly the same, in $line, this doesn't work.. this isn't too probable though
    } else {
      eval("\$dt_result=\"".ereg_replace("{{","{",$line)."\";");             	// no multiples, just replace double {{ with a single { and let eval fill in the values for variables
      return $dt_result;
    }
  } 

  Function EvalTemplate($templatefile, $vars) {
    return EvalLine(ereg_replace("\\\\\\\$","\$",ereg_replace("\"","\\\"",ereg_replace("\\\\","\\\\",implode(file($templatefile), "")))), $vars);
  }

  Function DisplayTemplate($templatefile, $vars) {
    echo EvalTemplate($templatefile, $vars);
  }
?>
